using System;

/*
 * The Blipos clock has 256 seconds in a minute and
 * 65536 minutes in a day. The night lasts for
 * 32768 minutes and is represented by negative minute values.
 * The daylight lasts 32767 minutes represented by postive
 * values. When minutes equals 0 it is neither day nor night.
 * The clock can tick forwards, backwards, be adjusted,
 * move fast forwards and fast backwards
 */

class BliposClock
{
    private byte seconds;
    private short minutes;
  
    public BliposClock()
    {
        seconds = 0;
        minutes = 0;
    }

    public void OneForward()
    {
        byte originalSeconds = seconds;
      
        seconds++;
        if(originalSeconds > seconds)
             // Overflow of seconds variable
            minutes++;
    }

    public void OneBackward()
    {
        byte originalSeconds = seconds;

        seconds--;
        if (originalSeconds < seconds)
             // Underflow of seconds variable
            minutes--;		
    }
  
    public void FastForward()
    {
        byte originalSeconds = seconds;
      
        seconds = (byte)(seconds + 50);
        if (originalSeconds > seconds)
             // Overflow of seconds variable
            minutes++;
    }
  
    public void FastBackward()
    {
        byte originalSeconds = seconds;

        seconds = (byte)(seconds - 50);
        if (originalSeconds < seconds)
             // Underflow of seconds variable
            minutes--;
    }

    public void SetSeconds(byte sec)
    {
        seconds = sec;
    }
  
    public void SetMinutes(short min)
    {
        minutes = min;
    }
  
    public void ShowTime()
    {
        Console.WriteLine("Sec: " + seconds + " Min: " + minutes);
    }
}
  
public class RunBliposClock
{
    public static void Main()
    {
        string command;
 
        Console.WriteLine("Welcome to the Blipos Clock. " +
            "256 seconds per minute " +
            "65536 minutes per day");
        BliposClock myClock = new BliposClock();
        Console.WriteLine("Please set the clock");
        Console.Write("Enter Seconds: ");
        myClock.SetSeconds(Convert.ToByte(Console.ReadLine()));
        Console.Write("Enter minutes: ");
        myClock.SetMinutes(Convert.ToInt16(Console.ReadLine()));
        Console.WriteLine("Enter (F)orward (B)ackward " +
            "(A)dd fifty (D)educt fifty (T)erminate");
        do
        {
            command = Console.ReadLine().ToUpper();
            if (command == "F")
                myClock.OneForward();
            if (command == "B")
                myClock.OneBackward();
            if(command == "A")
                myClock.FastForward();
            if(command == "D")
                myClock.FastBackward();
            myClock.ShowTime(); 
        } while (command != "T");
        Console.WriteLine("Thank you for using the Blipos Clock"); 
    }
}
