using System;

class Car
{
    private string brandName;
    private uint odometer; 
    
    public Car(string initialBrandName, uint initialOdometer)
    {
        brandName = initialBrandName;
        odometer = initialOdometer;
    }
    
    public Car()
    {
        brandName = "unknown";
        odometer = 0;
    }
    
    public virtual void PrintAllInfo()
    {
        Console.WriteLine("Brand name: " + brandName);
        Console.WriteLine("Odometer: " + odometer);
    }
}

class RacingCar : Car
{
    private string onBoardCameraName;
        
    public RacingCar(string initialBrandName, uint initialOdometer, 
        string initialCameraName) : base(initialBrandName, initialOdometer)
    {
        onBoardCameraName = initialCameraName;
    }
 
    public RacingCar() : base()
    {
       onBoardCameraName = "unknown";
    }
    
    public override void PrintAllInfo()
    {
        base.PrintAllInfo();
        Console.WriteLine("On board camera name: " + onBoardCameraName);
    }
}

class CarTester
{
    public static void Main()
    {
        RacingCar yourRacingCar = new RacingCar("Lotus", 2000, "Nikon");
        yourRacingCar.PrintAllInfo();
    }
}