using System;
using System.Timers;

class WeatherForecaster
{
    public static double CalculateRainfallDay10RegionA()
    {
         //Simulated complex calculations takes 5000 milliseconds
        System.Threading.Thread.Sleep(5000);
        Random randomizer = new Random();
        return (double)randomizer.Next(40,100);   
    }
}

class CropForecaster
{
    private double rainfallDay10RegionA;
    private bool rainfallDay10RegionANeedUpdate = true;    

    public CropForecaster()
    {
        Timer aTimer = new Timer();
        aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
        aTimer.Interval = 20000;
        aTimer.Enabled = true;
    }

    public double RainfallDay10RegionA
    {
        get
        {
            if (rainfallDay10RegionANeedUpdate)
            {
                rainfallDay10RegionA = WeatherForecaster.CalculateRainfallDay10RegionA();
                rainfallDay10RegionANeedUpdate = false;
                return rainfallDay10RegionA;
            }
            else
            {
                return rainfallDay10RegionA;   
            }
        }
    }
    
    private double ComplexResultA()
    {
         //Arbitrary calculation involving lots of calls to rainfallDay10RegionA
        return ((RainfallDay10RegionA / 2) + (RainfallDay10RegionA / 3) + 
            (RainfallDay10RegionA / 4));   
    }
    
    private double ComplexResultB()
    {
         //Arbitrary calculation involving even more calls to rainfallDay10RegionA
        return (RainfallDay10RegionA / 10 - 100) + (RainfallDay10RegionA / 100);
    }
    
    public double WheatCropSizeInTonsInRegionA ()
    {
         //More arbitrary calculations returning a nice big result
        Console.WriteLine("Commencing forecast calculations. Please wait...");
        return (ComplexResultA() / 2 + ComplexResultB() / 4 + 
            ComplexResultA()) * 100000;
    }
    
    public void OnTimedEvent(object source, ElapsedEventArgs e)
    {
         //This method is currently called every 20 seconds automatically
        Console.WriteLine("\n\nNew Update Needed\nPerform another forecast?");
        rainfallDay10RegionANeedUpdate = true;
    }
}

class ForecastTester
{
    public static void Main()
    {
        string answer;
        CropForecaster myForecaster = new CropForecaster();
        
        Console.Write("Would you like to perform a crop forecast? Y)es N)o ");
        answer = Console.ReadLine().ToUpper();
        while (!(answer == "N"))
        {
            Console.WriteLine("Wheat crop size in tons: {0:N2}",
                myForecaster.WheatCropSizeInTonsInRegionA());
            Console.Write("Would you like to perform another crop forecast? Y)es N)o ");
            answer = Console.ReadLine().ToUpper();    
        }
    }
}
