using System;
using System.Collections;
  
class Account
{
    public static uint totalAccountsCreated = 0;
          
    public Account()
    {
        totalAccountsCreated++;
    } 
}
  
class Bank
{
    private ArrayList accounts;
       
    public Bank()
    {
        Console.WriteLine("Congratulations! You have created a new bank");
        accounts = new ArrayList();
    }
      
    public void AddNewAccount()
    {
        accounts.Add(new Account());
        Console.WriteLine("New account added!");
        PrintStatistics();
    }
     
    public void RemoveFirstAccount()
    {
        if (accounts.Count > 0)
        {
            accounts.RemoveAt(0);
            Console.WriteLine("Account removed!\n");
            PrintStatistics();
        }
        else
        {
            Console.WriteLine("Sorry no more current accounts");
        }
    }
     
    public void PrintStatistics()
    {
        Console.WriteLine("Number of current accounts:" + accounts.Count +
            "\nNumber of new accounts created: " + Account.totalAccountsCreated);
    }  
}
  
class DynamicBankSimulation
{
    private static Bank bigBucksBank;
      
    public static void Main()
    {
        string command;
                 
        bigBucksBank = new Bank();       
        do
        {
            PrintMenu();
            command = Console.ReadLine().ToUpper();
            switch (command)
            {
                case "A":
                    bigBucksBank.AddNewAccount();
                    break;
                case "E":
                    Console.WriteLine("Bye Bye!");
                    break;
                case "R":
                    bigBucksBank.RemoveFirstAccount();
                    break;
                case "P":
                    bigBucksBank.PrintStatistics();
                    break;
                default:
                    Console.WriteLine("Invalid choice");
                    break;
            }
        } while (command != "E");
    }
         
    private static void PrintMenu()
    {
        Console.WriteLine("\nWhat would you like to do?\n" +
            "A) Add new account\n" +
            "R) Remove account\n" +
            "P) Print statistics\n" +
            "E) End session\n");
    }
}
