using System;

class FindTheIslandGame 
{ 
    public static void Main()
    {
        NavigationSystem navigator;
        int numberOfRows;
        int numberOfColumns;      
        byte rowGuess = 0;
        byte columnGuess = 0; 
        string answer;

        do
        {
             //Let user determine the size of the map
            Console.WriteLine("First Choose size of map: ");
            Console.Write("Enter number of rows: ");
            numberOfRows = Convert.ToInt32(Console.ReadLine());
            Console.Write("Enter number of columns: ");
            numberOfColumns = Convert.ToInt32(Console.ReadLine());
            navigator = new NavigationSystem(numberOfRows, numberOfColumns);                 
             
            Console.WriteLine("\nBelow is a map of the ocean:\n" +
                "There is a hidden island behind one of the waves\n" +
                "Can you find it?\n" + 
                "Make a (qualified) guess by entering a row and a column\n" +
                "Every second guess is evaluated in East West direction\n" +
                "The remaining guesses in North South direction\n" +
                "An E in the map means the Island is to the East of this point\n" +
                "W means to the west; N to the North and S to the South\n" +
                "R means correct row but wrong column\n" + 
                "C means correct column but wrong row\n");
            navigator.PrintMap();    
            do
            {
	          Console.Write("\nEnter row: ");
	          rowGuess = Convert.ToByte(Console.ReadLine());
	          Console.Write("Enter column: ");
	          columnGuess = Convert.ToByte(Console.ReadLine());
            } while (!navigator.EvaluateGuess(rowGuess, columnGuess));
            Console.WriteLine("\nWell done! The letter I marks the island");
            Console.WriteLine("You found the island in {0} guesses",
                navigator.GetNumberOfGuesses());
            Console.WriteLine("\nCare to play another game? Y)es N)o");
            answer = Console.ReadLine().ToUpper();
        } while (answer == "Y"); 
    }
}

class NavigationSystem
{
    char [,] map;
    byte secretRow = 0;
    byte secretColumn = 0;
    int guessCounter = 0;
    
    public NavigationSystem(int rows, int columns)
    {
        map = new char [rows, columns];
         //Randomly choose a secret location for the island.
        Random randomizer = new Random();
        secretRow = (byte)randomizer.Next(0, map.GetLength(0)-1);
        secretColumn = (byte)randomizer.Next(0, map.GetLength(1)-1);
         // Fill the map with ~ to symbolize waves
        for (int i = 0; i < map.GetLength(0); i++)
        {
            for(int j = 0; j < map.GetLength(1); j++)
            map[i,j] = '~';
        }    
        guessCounter = 0;  
    }
        
    public void PrintMap()
    {
        byte count = 0;
        Console.Write("  ");
        for (int i = 0; i < map.GetLength(1); i++)
        {
            if (count == 10)
                count = 0;
            Console.Write(count);
            count++;        
        }
        Console.WriteLine();   
    	  for (int j = 0; j < map.GetLength(0); j++)
	  {
	      Console.Write(j + ((j < 10) ? " " : ""));
	      for(int i = 0; i < map.GetLength(1); i++)
	          Console.Write(map[j,i]);
	      Console.WriteLine();
	  }
    }
    
    public bool EvaluateGuess (int rowGuess, int columnGuess)
    {
        bool islandFound = false;
        guessCounter++;
         //If location is not found and guessCounter is even 
         //then check guess for North South direction
	   //otherwise check for East West direction
        if ((rowGuess == secretRow) && (columnGuess == secretColumn))
        {
	      map[rowGuess, columnGuess] = 'I';
	      islandFound = true;
	  }   
        else if (guessCounter % 2 == 0)
	  {
            if (rowGuess < secretRow)
                map[rowGuess, columnGuess] = 'S'; 
            else if (rowGuess > secretRow)
                map[rowGuess, columnGuess] = 'N';
            else
                map[rowGuess, columnGuess] = 'R';           
	  }
	  else
	  {
	      if (columnGuess < secretColumn)
	          map[rowGuess, columnGuess] = 'E';
	      else if (columnGuess > secretColumn)
	          map[rowGuess, columnGuess] = 'W';
	      else
	          map[rowGuess, columnGuess] = 'C';
	  }
	  PrintMap();
	  return islandFound;
    }
    
    public int GetNumberOfGuesses()
    {
        return guessCounter;
    }
    
}
