using System;

class Bacterium
{
    private static int bacteriaCreated;
    private static int tempBacteriaDestructed;
    private static int totalBacteriaDestructed;
    private static bool showBacteriaDestructed;
    private static bool hasGCJustRun;
    
    private int number;             
    private string name;
    private string shape;
    private string growthMethod;
    private string group;
    
    public Bacterium ()
    {
        if (hasGCJustRun)
        {
            Console.WriteLine("Bacterium objects destructed during GC Run: {0}", 
                tempBacteriaDestructed);
            Console.WriteLine("Difference between bacteria created " +
                "and bacteria destructed {0}", 
                (bacteriaCreated - totalBacteriaDestructed));
            Console.WriteLine("Resuming creating bacteria from number: {0}\n",
                bacteriaCreated);
            hasGCJustRun = false; 
        }
        
        bacteriaCreated++;
        number = bacteriaCreated;
        name = "Streptococcus";
        shape = "round";
        growthMethod = "chains";
        group = "alpha";    
    }
    
    static Bacterium ()
    {
        bacteriaCreated = 0;
        tempBacteriaDestructed = 0;
        totalBacteriaDestructed = 0;
        showBacteriaDestructed = false;
        hasGCJustRun = false;
    }
    
    ~Bacterium()
    {
        if(!hasGCJustRun)
        {
            Console.WriteLine("Creation temporarily stopped " +
                "at Bacterium number: {0} to perform destruction", bacteriaCreated);
            hasGCJustRun = true;
            tempBacteriaDestructed = 0;
        }
        if (showBacteriaDestructed)
        {
            Console.WriteLine("Bacterium: {0} destructed", number);
        }
        tempBacteriaDestructed++;
        totalBacteriaDestructed++;
    }
    
    public static void SetShowBacteriaDestructed (bool showIt)
    {
        showBacteriaDestructed = showIt;
    }
    
    public static int GetTotalBacteriaDestructed ()
    {
       return totalBacteriaDestructed; 
    }
    
    public static int GetTotalBacteriaCreated ()
    {
        return bacteriaCreated;
    }
}

class Body
{
    public static void Main()
    {
        int bacteriaCreatedBeforeCollect;
        int maxBacteria;
        Bacterium newBacterium;
 
        Console.Write("How many bacteria do you want to create? ");
        maxBacteria = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter amount of bacteria to create " +
            "before asking GC to run: ");
        bacteriaCreatedBeforeCollect = Convert.ToInt32(Console.ReadLine());
        Console.Write("Do you want to see each " +
            "Bacterium number when destructed? Y)es N)o ");
        if (Console.ReadLine().ToUpper() == "Y")
            Bacterium.SetShowBacteriaDestructed (true);
        else
            Bacterium.SetShowBacteriaDestructed (false);
        Console.WriteLine("\nCreation commencing\n");
        
        for (int i = 0; i < maxBacteria; i++)
        {
            newBacterium = new Bacterium();
            if (i == (bacteriaCreatedBeforeCollect - 1))
            {
                Console.WriteLine("Initiating GC to run " +
                    "after Bacterium number: {0} has been created", (i + 1));
                GC.Collect();
            }
        }
        
        Console.WriteLine("\nCreation stopped at bacterium number: {0}", 
            Bacterium.GetTotalBacteriaCreated());
        Console.WriteLine("Total Bacteria objects destructed " +
            "during execution of program: {0}",
            Bacterium.GetTotalBacteriaDestructed());
    }
}