using System;
 
delegate double DoCalculate(double num);
 
class RocketCalculator
{
    private DoCalculate[] calculations;
    private int calculationCounter;
     
    public RocketCalculator()
    {
        calculationCounter = 0;
        calculations = new DoCalculate[10];
    }
     
    public void AddCalculation(DoCalculate newCalculation)
    {
        calculations[calculationCounter] = newCalculation;
        calculationCounter++;
    }
     
    public double StartCalculation(double tempValue)
    {
        Console.WriteLine("Start value: {0}", tempValue);   
        for (int i = 0; i < calculationCounter; i++)
        {
            tempValue = calculations[i](tempValue);       
        }
        return tempValue;
    }
}
 
class Math
{
    public static DoCalculate DoMinusTwenty = new DoCalculate(MinusTwenty);
    public static DoCalculate DoTimesTwo = new DoCalculate(TimesTwo);
    public static DoCalculate DoPlusTen = new DoCalculate(PlusTen);
 
    public static double MinusTwenty(double number)
    {
        Console.WriteLine("Minus twenty");
        return number - 20;
    }
     
    public static double TimesTwo(double number)
    {
        Console.WriteLine("Times two");
        return number * 2;
    }
    
    public static double PlusTen(double number)
    {
        Console.WriteLine("Plus ten");
        return number + 10;
    }  
}

public class Tester
{
    public static void Main()
    {
        double startValue;
        double endResult;
        string response;
        
        RocketCalculator calculator = new RocketCalculator();
        
        Console.Write("Enter start value: ");
        startValue = Convert.ToDouble(Console.ReadLine());
        Console.WriteLine("Create sequence of operations by repeatedly");
        Console.WriteLine("choosing from the following options");
        Console.WriteLine("M)inus twenty");
        Console.WriteLine("T)imes two");
        Console.WriteLine("P)lus ten");
        Console.WriteLine("When you wish to perform the calculation enter C\n");
        
        do
        {
            response = Console.ReadLine().ToUpper();
            switch(response)
            {
                case "M":
                    calculator.AddCalculation(Math.DoMinusTwenty);
                    Console.WriteLine("Minus twenty operation added");
                break;
                case "T":
                    calculator.AddCalculation(Math.DoTimesTwo);
                    Console.WriteLine("Times two operation added");
                break;
                case "P":
                    calculator.AddCalculation(Math.DoPlusTen);
                    Console.WriteLine("Plus ten operation added");
                break;
                case "C":
                    endResult = calculator.StartCalculation(startValue);
                    Console.WriteLine("End result: {0}", endResult);
                break;
                default:
                    Console.WriteLine("Invalid choice please try again");
                break;
            }
        } while (response != "C");
    }
}




