using System;

class Light
{
     // Speed of light in kilometers per second
    public const double Speed = 299792; 
    private double timeTraveled;
    private double distanceTraveled;
    
    public static double CalculateDistance (double seconds)
    {
        return seconds * Speed;
    }
    
    public static double CalculateTime (double distance)
    {
        Light someLight = new Light();
        someLight.SetDistanceTraveled(distance);
        return someLight.GetTimeTraveled();
    }

    public void SetTimeTraveled (double newTimeTraveled)
    {
        timeTraveled = newTimeTraveled;
    }
    
    public void SetDistanceTraveled (double newDistanceTraveled)
    {
        distanceTraveled = newDistanceTraveled;
    }

    public double GetDistanceTraveled ()
    {
        return CalculateDistance (timeTraveled);
    }
    
    public double GetTimeTraveled ()
    {
        return distanceTraveled / Speed;
    }
}

class SolarSystem
{
    public static void Main()
    {
        Light sunRay = new Light();
        Console.WriteLine("Speed of light: {0} kilometers per hour", Light.Speed);
        sunRay.SetTimeTraveled(240);
        Console.WriteLine("The sunray has traveled {0} kilometers after 240 seconds",
            sunRay.GetDistanceTraveled());
        Console.WriteLine("Light travels {0} kilometers after 480 seconds",
            Light.CalculateDistance(480));
        Console.WriteLine("It takes {0:N2} seconds for a ray of sunshine", 
            Light.CalculateTime(150000000)); 
        Console.WriteLine("to travel from the sun to the earth");
    }   
}