using System;

namespace Animals
{
    class Dog
    {
        private string name;
        
        public Dog()
        {
            name = "unknown";
        }
        
        public Dog(string initialName)
        {
            name = initialName;
        }
    
        public string Name
        {
            get
            {
                return name;
            }
        }
    }
}

class ObjectTester
{
    public static void Main()
    {
        Type dogType;
        Animals.Dog myDog = new Animals.Dog("Fido");
        Animals.Dog yourDog = new Animals.Dog("Pluto");
        Animals.Dog sameDog = myDog;
        
        Console.WriteLine("ToString(): " + myDog.ToString());
        dogType = myDog.GetType();
        Console.WriteLine("Type: " + dogType.ToString());
        
        if(myDog.Equals(yourDog))
            Console.WriteLine("myDog is referencing the same object as yourDog");
        else
            Console.WriteLine("myDog and yourDog are referencing different objects");
                
        if(myDog.Equals(sameDog))   
            Console.WriteLine("myDog is referencing the same object as sameDog");
        else
            Console.WriteLine("myDog and sameDog are referencing different objects");
        
        if(object.ReferenceEquals(myDog, yourDog))
            Console.WriteLine("myDog and yourDog are referencing the same object");
        else
            Console.WriteLine("myDog and yourDog are referening different objects");      
    }
}